
//  GAMEWORLD.java         CS 120     Fall 2016      Assignement A9
//                                 Instr.  J. Horn
//
//  A9 instructions:    The general idea is to take this game, which works,
//                      but only with three targets, and add an array of
//  targets, just like the "targetArray" in the accompanying code "Tester_
//  with_arrays.java", so that your game can have any number of targets
//  (e.g., 40).
//
//  Specific steps:   (1)  PLAY THE GAME!
//                         Compile and run this code to see how the game
//                         plays.   Note that this folder should also
//                         contain all the class definitions you need,
//                         (either the .class or .java files), including
//                         Target (the interface), and any specific Target
//                         implementation classes that you feel like using,
//                         such as JeffTarget, or your own class
//                         that implements the Target interface.
//     (2)  READ THE SOURCE:  It is pretty well commented.  There is plenty of
//                            of good stuff, such as the double buffering and
//                            multi-threading, for animation.
//     (3)  ADD AN ARRAY:  There are TEN (10) places where you need to add
//                         array code.   These are identified by a comment with
//                         "**** A9 ARRAY NEEDED HERE  *****" in it, (number of
//                         stars varies!).   These 10 places are in the methods
//                         "init", "run", "paint", and "GameWorld" (that's the
//                         constructor method).   Also, you need array code in
//                         state variable declarations to declare the array.
//                         (There you can use the array declaration from
//                         "Tester_with_arrays".)  Note there is no need for
//                         array code in mousePressed (that method is now very
//                         short and simple for this game!).  There is no need
//                         to alter any other code.
//     (4)  USE EXAMPLE:   Look to "Tester_with_arrays" for guidance. Expecially
//                         for declaring the array in the state var. declaration
//                         area, and then for creating the array and filling it
//                         with Target objects using "new" (all this in the
//                         constructor method).   Declaring and creating the
//                         array will probably be the "weirdest" new concept.
//     (5)  TIPS:          It is not a lot of code to write.  Just remember that,
//                         (assuming your array is named"targetArray" as in the
//                         Tester_with_arrays code), "targetArray[0]" or
//                         "targetArray[1]" or "targetArray[2]" or "targetArray[i]"
//                         is an OBJECT of class Target, and can be used anywhere
//                         that you can use an individually named object, such
//                         as "target1" below.  Thus if I can call a method with
//                         "target1.move();", then I can also call it with
//                         "targetArray[i].move();", for 0 <= i < MAX. (Note that
//                         there is no such object "targetArray[MAX]".  The last
//                         object in an array of size MAX is targetArray[MAX-1].
//                         This is because the array stores the MAX objects in
//                         positions 0 to MAX-1 (and NOT 1 to MAX).)   Similarly,
//                         if you are calling a method with an object, such as
//                         "inside(target2,mx,my);" you can also call it using
//                         an array element with "inside(targetArray[i],mx,my);".
//    (6)  SUBMISSION:  Email me your file "GameWorld.java" as an attachment.
//                      As usual, put "CS 120:  A9" in the subject line.  Also,
//                      put your name in the top line of the file, please, so it
//                      it is in the source code.
//
//

import java.awt.*;
import java.awt.event.*;

public class GameWorld extends java.applet.Applet implements MouseListener, Runnable
       {
		 //  State variable declarations

        /////////////////   Needed for DOUBLE BUFFERING    ///////////////////////
		   Graphics buffg;   //    Extra graphics object
		   Image offscreen;  //    An image object to contain the graphics object
             //      "buffg".  This image object can be drawn
             //      on our usual graphics object (in the applet window)
             //      using "drawImage.
        /////////////////////  end of code for DOUBLE BUFFERING //////////////////

		 private int mx, my;    //   Coordinates of last mouse click.
         private Target target1,target2, target3; // Three Target objects

         //  *************   A9 ARRAY NEEDED HERE  (1)  *************
         //    Declare an array of Target


         //  Explosion variables
			 private boolean exploding = false;
			 private int explosionX, explosionY;
			 private int explosion_radius;

         //  CONSTANTS for the GameWorld
             private final int NUM_TARGETS = 100;
			 private final int LEFT_WALL = 10;     //  Boundaries of playing field.
			 private final int TOP_WALL = 10;
			 private final int RIGHT_WALL = 800;
			 private final int BOTTOM_WALL = 500;
			 private final int TARGET_WIDTH = 40;  //  We agreed to 40x40 in the
			 private final int TARGET_HEIGHT = 40; //     in Target.java.
			 private final int INITIAL_SCORE = 40; //  Score that all targets get at start.
			 private final int TARGET_SPEED = 4;   // in pixels per FRAME_PERIOD.
			 private final int FRAME_PERIOD = 10;  // Number of milliseconds of Thread.sleep()
			 private final Color EXPLOSION_COLOR = Color.magenta;
			 private final int MAX_EXPLOSION_RADIUS = 60;      // in pixels
			 private final int EXPLOSION_DAMAGE = -1; // Amt added to score each time target hit.
			 private final int EXPLOSION_DURATION_WALL_CLOCK_TIME = 200; // How many milliseconds
																		 // explosion lasts.
			 private final int EXPLOSION_DURATION_NUMBER_OF_FRAMES =  // How many frames explosion
							   (int) (EXPLOSION_DURATION_WALL_CLOCK_TIME / FRAME_PERIOD); // lasts.

		 public GameWorld()  //  Constructor method for GameWorld class.
		   { //  All we need to do here is to create the targets.
                  target1 = new JeffTarget();
                  target2 = new JeffTarget();
                  target3 = new JeffTarget();
                  //  *************   A9 ARRAY NEEDED HERE (2) *************
                  //  Fill array with new Target objects


		   }

		 public void init( )      //   Initialization.  This method called
		 	{                     //   just once.

				  /////////////////  for DOUBLE BUFFERING  ///////////////////////////////////
				  offscreen = createImage(900,600);
					//  Create a new image object, with same
					//  size as our applet window, so it will
				   //  fit perfectly when we draw it there.
				  buffg = offscreen.getGraphics();
					//  Get the graphics object from the image object so
					//  that we can draw in it in "paint" below.
				  /////////////////  end of code for DOUBLE BUFFERING  ///////////////////////

				  addMouseListener( this );

                  // Move targets to initial locations
					  int randomX,randomY;

					  // First move target1
					  randomX = LEFT_WALL + (int)(Math.random()*(RIGHT_WALL-LEFT_WALL-10)+5);
					  randomY = TOP_WALL + (int)(Math.random()*(BOTTOM_WALL-TOP_WALL-10)+5);
					  target1.setXY(randomX,randomY);

					  // Next move target2
					  randomX = LEFT_WALL + (int)(Math.random()*(RIGHT_WALL-LEFT_WALL-10)+5);
					  randomY = TOP_WALL + (int)(Math.random()*(BOTTOM_WALL-TOP_WALL-10)+5);
					  target2.setXY(randomX,randomY);

                      // Finally, move target3
                      randomX = LEFT_WALL + (int)(Math.random()*(RIGHT_WALL-LEFT_WALL-10)+5);
					  randomY = TOP_WALL + (int)(Math.random()*(BOTTOM_WALL-TOP_WALL-10)+5);
                      target3.setXY(randomX,randomY);

                      //  *************   A9 ARRAY NEEDED HERE  (3) *************
                      //  Move all the targets in the array to random start positions.


                  //  Give all targets same initial score
					  target1.setScore(INITIAL_SCORE);
					  target2.setScore(INITIAL_SCORE);
					  target3.setScore(INITIAL_SCORE);

                      //  *************   A9 ARRAY NEEDED HERE (4) *************
                      //  Give all the targets in the array the same initial score.

				  new Thread(this).start();  //  Multi-threading.  We'll run
					// two threads.  One for listening to input from user,
					// including window resizes, etc., and the other just
					// runs the "game loop" in the "run" method below.

				  //  Give all targets initial velocities.
					  int randomXvel;
					  int randomYvel;
                      //  First set target1's velocity randomly.
					  randomXvel = 1+(int) (Math.random() * TARGET_SPEED);
					  randomYvel = 1+(int) (Math.random() * TARGET_SPEED);
					  target1.setXYvelocity(randomXvel,randomYvel);
					  //  Then set target2's velocity randomly.
					  randomXvel = 1+ (int) (Math.random() * TARGET_SPEED);
					  randomYvel = 1+ (int) (Math.random() * TARGET_SPEED);
					  target2.setXYvelocity(randomXvel,randomYvel);
					  //  Then set target3's velocity randomly.
					  randomXvel = 1+(int) (Math.random() * TARGET_SPEED);
					  randomYvel = 1+(int) (Math.random() * TARGET_SPEED);
					  target3.setXYvelocity(randomXvel,randomYvel);
                      //  *************   A9 ARRAY NEEDED HERE  (5) *************
                      //  Set velocity randomly for all targets in array.

		 	}
		public void update(Graphics g)
		{
			paint(g); // This method overrides the default "update" method which would first wipe off
					  //  existing images, which would also cause flicker.  ("repaint" calls "update"
					  //  which then calls "paint")
		}

        public void run()   // Multi-threading.  This method runs the
         {                  //  "game loop" which keeps things moving
                            //   and animated.
			 int newX = 0;
			 int newY =0;
			 char direction;
             int randomDeltaX;
             int randomDeltaY;

			 while(true)
			   {
                    // Move all three targets.
						target1.move();
						target2.move();
						target3.move();
					    //  *************   A9 ARRAY NEEDED HERE  (5)  *************
					    //  Move all targets in array

                    //  Make targets bounce off walls, if necessary!
						checkForWallBounce(target1);
						checkForWallBounce(target2);
						checkForWallBounce(target3);
                        //  *************   A9 ARRAY NEEDED HERE (6) *************
                        //  For all targets in array, make sure they bounce of walls.


                   //  Update explosion, if exploding...
					   if(exploding)
						 {
							 // Check to see which targets get hit.
								 checkForHit(target1);
								 checkForHit(target2);
								 checkForHit(target3);
							    //  *************   A9 ARRAY NEEDED HERE (7) *************
							    //  For all targets in array, check to see if it got hit.

							 // UPDATE EXPLOSION
							 explosion_radius +=
							     MAX_EXPLOSION_RADIUS/EXPLOSION_DURATION_NUMBER_OF_FRAMES;
							 if(explosion_radius > MAX_EXPLOSION_RADIUS) {exploding = false;}
						 }

				    repaint();

					//  Pause for FRAME_PERIOD milliseconds so animation does not
					//  run too fast to see!
					  try{ Thread.sleep(FRAME_PERIOD); }
						   catch(Exception e)  {}
			   }
		 }

         public void paint(Graphics g)
              {

				 //   Clear the screen in the buffg graphics obj.
					 buffg.clearRect(0,0,RIGHT_WALL+20,BOTTOM_WALL+20);
					 buffg.setColor(Color.white);
					 buffg.drawRect(0,0,RIGHT_WALL+20,BOTTOM_WALL+20);

				 //  Draw blue border rectangle to show borders of playing field
					 buffg.setColor( Color.blue );
					 buffg.drawRect( LEFT_WALL, TOP_WALL,
					                 RIGHT_WALL-LEFT_WALL, BOTTOM_WALL-TOP_WALL );

                 //  PAINT TARGETS
					 buffg.setColor( Color.black );
					 target1.paint(buffg);     //  Paint all three targets.
					 target2.paint(buffg);
					 target3.paint(buffg);
                     //  *************   A9 ARRAY NEEDED HERE  (8) *************
                     //  Paint every target in array.

                 //   Print targets' scores just below targets.
					  buffg.setColor(Color.blue);
					  buffg.drawString(""+target1.getScore(),target1.getX()+10,target1.getY()+55);
					  buffg.drawString(""+target2.getScore(),target2.getX()+10,target2.getY()+55);
					  buffg.drawString(""+target3.getScore(),target3.getX()+10,target3.getY()+55);
                      //  *************   A9 ARRAY NEEDED HERE  (9)  *************
                      //  Print score of every target in array.

                  //  Print getEpitaphs of any dead targets, just above them.
					  if(target1.getScore() < 0)
						 buffg.drawString(target1.getEpitaph(),target1.getX(),target1.getY()-5);
					  if(target2.getScore() < 0)
						 buffg.drawString(target2.getEpitaph(),target2.getX(),target2.getY()-5);
					  if(target3.getScore() < 0)
						 buffg.drawString(target3.getEpitaph(),target3.getX(),target3.getY()-5);
                      //  *************   A9 ARRAY NEEDED HERE  (10)  *************
                      //   Print getEpitaph of evey target in array.





                 //  EXPLOSION.  Draw an eight-pointed star (an asterisk).
					 if(exploding)
						{
							buffg.setColor(EXPLOSION_COLOR);
							buffg.drawLine(explosionX,explosionY,explosionX+explosion_radius,explosionY);
							buffg.drawLine(explosionX,explosionY,explosionX-explosion_radius,explosionY);
							buffg.drawLine(explosionX,explosionY,explosionX,explosionY+explosion_radius);
							buffg.drawLine(explosionX,explosionY,explosionX,explosionY-explosion_radius);
							buffg.drawLine(explosionX,explosionY,explosionX + (int) (explosion_radius/1.414),explosionY + (int) (explosion_radius/1.414));
							buffg.drawLine(explosionX,explosionY,explosionX + (int) (explosion_radius/1.414),explosionY - (int) (explosion_radius/1.414));
							buffg.drawLine(explosionX,explosionY,explosionX - (int) (explosion_radius/1.414),explosionY + (int) (explosion_radius/1.414));
							buffg.drawLine(explosionX,explosionY,explosionX - (int) (explosion_radius/1.414),explosionY - (int) (explosion_radius/1.414));
						}

			      g.drawImage(offscreen,0,0,this);  //  Doublebuffering.  Now
			       // that we are finished drawing on the buffg object,
			       // tell graphics obj. g to draw the "offscreen" image,
			       // which contains buffg.

 			  }

		 public void mouseExited(MouseEvent me) {}
		 public void mouseEntered(MouseEvent me) {}
		 public void mouseClicked( MouseEvent me) {}
		 public void mouseReleased( MouseEvent me) {}
	     public void mousePressed( MouseEvent me)
	        {
				mx = me.getX();    //  Get coordinates of mousepress event.
				my = me.getY();

				//  If an explosion is already happening, then ignore mousepress.
				//  If no explosion currently, and mousepress is inside of
				//  playing field, then start an explosion.
				if(! exploding  &&  LEFT_WALL < mx && mx < RIGHT_WALL  &&
				     TOP_WALL < my && my < BOTTOM_WALL ) //
				    {
						exploding = true;   //  Update state var. to indicate explos.
						explosionX = mx;    //  Record location of this new explos.
						explosionY = my;
						explosion_radius = 0; //  Start with small explosion, to incr.
					}


                repaint();    //  Update graphics window.
		    }

          //  Given Target t, check to see if t has moved beyond any of the four walls
          //   of the game world (LEFT, TOP, RIGHT, BOTTOM).  If t has moved beyond LEFT
          //   or RIGHT, reverse its X velocity (by changing its sign).   If t has moved
          //   beyond TOP or BOTTOM, then reverse its Y velocity.
          private void checkForWallBounce(Target t)
            {
				if(t.getX() < LEFT_WALL  || t.getX() > RIGHT_WALL-TARGET_WIDTH)
					{t.setXYvelocity(-1 * t.getXvelocity(), t.getYvelocity() );}
				if(t.getY() < TOP_WALL  ||  t.getY() > BOTTOM_WALL-TARGET_HEIGHT)
					{t.setXYvelocity(t.getXvelocity(), -1 * t.getYvelocity() );}

			}

          //  Check to see if Target t is being "hit" by the current explosion.
          //  If so, then give t damage.   If t is dead, then stop its movement
          //  by setting its velocity to zero.
          private void checkForHit(Target t)
            {
				//  Check each of the eight end-points of the explosion star.
				//  If any end-points are inside of t, then cause damage to t.
				if(     inside(t,explosionX+explosion_radius,explosionY)
				    ||  inside(t,explosionX-explosion_radius,explosionY)
				    ||  inside(t,explosionX,explosionY+explosion_radius)
				    ||  inside(t,explosionX,explosionY-explosion_radius)
				    ||  inside(t,explosionX + (int) (explosion_radius/1.414),
				                 explosionY + (int) (explosion_radius/1.414))
				    ||  inside(t,explosionX + (int) (explosion_radius/1.414),
				                 explosionY - (int) (explosion_radius/1.414))
				    ||  inside(t,explosionX - (int) (explosion_radius/1.414),
				                 explosionY + (int) (explosion_radius/1.414))
				    ||  inside(t,explosionX - (int) (explosion_radius/1.414),
				                 explosionY - (int) (explosion_radius/1.414))
				   )

				  {
					  t.addToScore(EXPLOSION_DAMAGE);  //  Cause damage to t.
					  // If t dead, then stop its movement by setting its velocity
					  if(t.getScore() < 0)  {t.setXYvelocity(0,0);}   //  to zero.
				  }

			}

          //  INSIDE(t,x,y).  Because I forgot to add the all-important "inside" method
          //  to the Target interface, I cannot expect your Target class to have such a
          //  method.  Fortunately, the interface is rich enough in methods that there
          //  ARE some we can use to make our own "inside" method.
          //  This method returns TRUE if and only if (x,y) is inside the 40 by 40 pixel
          //  bounding box of the Target t, specifically the box with upper left corner
          //  at location (t.getX(), t.getY()).
          private boolean inside(Target t, int x, int y)
            {
				return (t.getX() < x && x < t.getX() +40 && t.getY() < y && y < t.getY()+40) ;
			}

	    }


