
//  TESTER_with_ARRAYS.java         CS 120     Fall 2016     Assignment A9
//                                 Instr.  J. Horn
//
//



import java.awt.*;
import java.awt.event.*;

public class Tester_with_arrays extends java.applet.Applet implements MouseListener, KeyListener
       {
		 //  State variable declarations

		 private int mx, my;    //   Coordinates of last mouse click.
         private Target target1,target2, target3; // Three Target objects
         private Target selected;   //   Holds the one target that is currently selected



         private Button moveLeft;
         private Button moveRight;
         private Button damage;


		 public Tester_with_arrays()
		   {
                  target1 = new JeffTarget();    // CHANGE "JeffTarget
                  target2 = new JeffTarget();    // TO YOUR CLASS NAME
                  target3 = new JeffTarget();    // IN ALL THREE LINES.

                  selected = target1;


				  moveLeft = new Button(80, 130, 30, 50, "LEFT");
				  moveRight = new Button(150, 200, 30, 50, "RIGHT");
				  damage = new Button(220, 300, 30, 50, "DAMAGE (-5)");
				  init();
		   }

		 public void init( )      //   Initialization.  This method called
		 	{                     //   just once.
				  addMouseListener( this );
				  addKeyListener(this);
				  target1.setXY(50,200);   // Move targets to initial
				  target2.setXY(100,200);  // locations.
                  target3.setXY(150,200);
                  target1.setScore(100);      //  Give all targets 100 pts.
				  target2.setScore(100);
                  target3.setScore(100);


		     }
         public void paint(Graphics g)
              {
				  g.setColor(Color.black);

                  target1.paint(g);     //  Paint all three targets.
                  target2.paint(g);
                  target3.paint(g);


                  g.setColor(Color.blue); //   Print targets' scores just below targets.
                  g.drawString(""+target1.getScore(),target1.getX()+10,target1.getY()+55);
                  g.drawString(""+target2.getScore(),target2.getX()+10,target2.getY()+55);
                  g.drawString(""+target3.getScore(),target3.getX()+10,target3.getY()+55);


                  //  Print getEpitaphs of any dead targets, just above them.
                  if(target1.getScore() < 0)
                     g.drawString(target1.getEpitaph(),target1.getX(),target1.getY()-5);
                  if(target2.getScore() < 0)
                     g.drawString(target2.getEpitaph(),target2.getX(),target2.getY()-5);
                  if(target3.getScore() < 0)
                     g.drawString(target3.getEpitaph(),target3.getX(),target3.getY()-5);



                  //    Paint all three buttons
                  moveLeft.paint(g);
                  moveRight.paint(g);
                  damage.paint(g);

                  //  Draw a red circle around the selected target.
                  if(selected != null)
                    {g.setColor(Color.red);
                     g.drawOval(selected.getX() - 5,selected.getY()-5, 50,50);}
 			  }

		 public void mouseExited(MouseEvent me) {}
		 public void mouseEntered(MouseEvent me) {}
		 public void mouseClicked( MouseEvent me) {}
		 public void mouseReleased( MouseEvent me) {}
	     public void mousePressed( MouseEvent me)
	        {
				mx = me.getX();
				my = me.getY();

				// TARGET SELECTION: Check all targets.  If mousepress was inside
				//   one of them, then select that target and unselect the others.
				if(inside(target1.getX(),target1.getY()))
				    {  selected = target1; }
				if(inside(target2.getX(),target2.getY()))
				    {  selected = target2; }
				if(inside(target3.getX(),target3.getY()))
				    {  selected = target3;}


				//  BUTTON CLICKS:   If mousepress was inside any button, then implement
				//                   that button's functionality for the selected target

                if(moveLeft.inside(mx, my))    //  LEFT button.
                    {selected.setXY(selected.getX()-2, target1.getY());}
                        // Move selected target left two pixels.
                if(moveRight.inside(mx, my))   //  RIGHT button.
                    {selected.setXY(selected.getX()+2, target1.getY());}
                        // Move selected target right two pixels.

                if(damage.inside(mx, my))     // DAMAGE button.  Reduce score of
                    {selected.addToScore(-5); } //   selected targets by 5.

                repaint();    //  Update graphics window.
		    }


          public void keyListener(KeyEvent e) {}
          public void keyReleased(KeyEvent e) {}
          public void keyTyped(KeyEvent e) {}
		  public void keyPressed(KeyEvent e) // respond to key strokes.
		   {
			  int changeAMT = 2; //  Amount to move, any direction, in pixels
			  int changeInX = 0; //  Amount to move in x-direction
			  int changeInY =0;  //  Amount to move in y-direction
			  if (e.getKeyCode() == KeyEvent.VK_UP)  //  If UP-ARROW pressed
			     {  changeInX = 0; changeInY = - changeAMT;  }  // move up.
			  else if (e.getKeyCode() == KeyEvent.VK_DOWN)   //  DOWN-ARROW...
			          {  changeInX = 0; changeInY = changeAMT;  }
			       else if (e.getKeyCode() == KeyEvent.VK_LEFT)//  LEFT-ARROW...
			               {  changeInX = - changeAMT; changeInY = 0;  }
			            else if (e.getKeyCode() == KeyEvent.VK_RIGHT) // RIGHT-ARROW
			                     { changeInX = changeAMT; changeInY = 0;  }
			  // Move only those Targets that are SELECTED.
              selected.setXY(selected.getX()+changeInX, selected.getY()+changeInY);

              repaint();
		   }
          //  INSIDE(t,x,y).  Because I forgot to add the all-important "inside" method
          //  to the Target interface, I cannot expect your Target class to have such a
          //  method.  Fortunately, the interface is rich enough in methods that there
          //  ARE some we can use to make our own "inside" method.
          //  This method returns TRUE if and only if (x,y) is inside the 40 by 40 pixel
          //  bounding box of the Target t, specifically the box with upper left corner
          //  at location (t.getX(), t.getY()).
          private boolean inside(Target t, int x, int y)
            {
				return (t.getX() < x && x < t.getX() +40 && t.getY() < y && y < t.getY()+40) ;
			}

	    }
